Index: files/BOOL.patch
===================================================================
--- files/BOOL.patch	(revision 90727)
+++ files/BOOL.patch	(working copy)
@@ -16,26 +16,8 @@
  #undef LoadResource
  #undef CompareString
  #undef GetCurrentThread
---- dlls/dinput/joystick_osx.c.orig	2012-02-13 11:57:04.000000000 -0800
-+++ dlls/dinput/joystick_osx.c	2012-02-13 11:57:27.000000000 -0800
-@@ -24,6 +24,7 @@
- #include "wine/port.h"
- 
- #if defined(HAVE_CARBON_CARBON_H) && defined(HAVE_IOKIT_HID_IOHIDLIB_H)
-+#define BOOL __carbon_BOOL
- #define LoadResource __carbon_LoadResource
- #define CompareString __carbon_CompareString
- #define GetCurrentThread __carbon_GetCurrentThread
-@@ -62,6 +63,7 @@
- #define STDMETHODCALLTYPE __carbon_STDMETHODCALLTYPE
- #include <Carbon/Carbon.h>
- #include <IOKit/hid/IOHIDLib.h>
-+#undef BOOL
- #undef LoadResource
- #undef CompareString
- #undef GetCurrentThread
---- dlls/windowscodecs/icnsformat.c.orig	2012-02-13 12:58:07.000000000 -0800
-+++ dlls/windowscodecs/icnsformat.c	2012-02-13 12:58:31.000000000 -0800
+--- dlls/windowscodecs/icnsformat.c.orig	2012-02-12 23:54:58.000000000 -0800
++++ dlls/windowscodecs/icnsformat.c	2012-02-12 23:55:20.000000000 -0800
 @@ -22,6 +22,7 @@
  #include <stdarg.h>
  
@@ -44,7 +26,7 @@
  #define GetCurrentProcess GetCurrentProcess_Mac
  #define GetCurrentThread GetCurrentThread_Mac
  #define LoadResource LoadResource_Mac
-@@ -37,6 +38,7 @@
+@@ -49,6 +50,7 @@
  #define ShowCursor ShowCursor_Mac
  #define UnionRect UnionRect_Mac
  #include <ApplicationServices/ApplicationServices.h>
@@ -52,34 +34,93 @@
  #undef GetCurrentProcess
  #undef GetCurrentThread
  #undef LoadResource
---- dlls/wineosxime.drv/mactext.c.orig	2012-02-13 14:31:06.000000000 -0800
-+++ dlls/wineosxime.drv/mactext.c	2012-02-13 14:31:58.000000000 -0800
-@@ -50,7 +50,9 @@
- #ifdef __APPLE__
+--- dlls/wineqtdecoder/qtdatahandler.c.orig	2012-02-13 00:04:58.000000000 -0800
++++ dlls/wineqtdecoder/qtdatahandler.c	2012-02-13 00:05:24.000000000 -0800
+@@ -23,6 +23,7 @@
+ #define ULONG CoreFoundation_ULONG
+ #define HRESULT CoreFoundation_HRESULT
  
- #include "wine/debug.h"
 +#define BOOL __carbon_BOOL
- #include <Carbon/Carbon.h>
+ #define LoadResource __carbon_LoadResource
+ #define CompareString __carbon_CompareString
+ #define GetCurrentThread __carbon_GetCurrentThread
+@@ -62,6 +63,7 @@
+ 
+ #include <QuickTime/QuickTimeComponents.h>
+ 
 +#undef BOOL
- #include <dlfcn.h>
- #include "IMKClient.h"
+ #undef LoadResource
+ #undef CompareString
+ #undef GetCurrentThread
+--- dlls/wineqtdecoder/qtsplitter.c.orig	2012-02-13 00:19:05.000000000 -0800
++++ dlls/wineqtdecoder/qtsplitter.c	2012-02-13 00:19:26.000000000 -0800
+@@ -23,6 +23,7 @@
+ #define ULONG CoreFoundation_ULONG
+ #define HRESULT CoreFoundation_HRESULT
  
---- dlls/wineqtdecoder/qtvdecoder.c.orig	2012-02-13 14:36:12.000000000 -0800
-+++ dlls/wineqtdecoder/qtvdecoder.c	2012-02-13 14:36:46.000000000 -0800
-@@ -22,6 +22,7 @@
++#define BOOL __carbon_BOOL
+ #define LoadResource __carbon_LoadResource
+ #define CompareString __carbon_CompareString
+ #define GetCurrentThread __carbon_GetCurrentThread
+@@ -63,6 +64,7 @@
+ #include <QuickTime/Movies.h>
+ #include <QuickTime/QuickTimeComponents.h>
  
++#undef BOOL
+ #undef LoadResource
+ #undef CompareString
+ #undef GetCurrentThread
+--- dlls/wineqtdecoder/qtutils.c.orig	2012-02-13 00:31:37.000000000 -0800
++++ dlls/wineqtdecoder/qtutils.c	2012-02-13 00:32:14.000000000 -0800
+@@ -23,6 +23,7 @@
  #define ULONG CoreFoundation_ULONG
  #define HRESULT CoreFoundation_HRESULT
-+#define BOOL CoreFoundation_BOOL
  
++#define BOOL __carbon_BOOL
  #define LoadResource __carbon_LoadResource
  #define CompareString __carbon_CompareString
-@@ -103,6 +104,8 @@
+ #define GetCurrentThread __carbon_GetCurrentThread
+@@ -62,6 +63,7 @@
  
- #undef ULONG
- #undef HRESULT
+ #include <CoreVideo/CVPixelBuffer.h>
+ 
 +#undef BOOL
-+
- #undef DPRINTF
- #undef STDMETHODCALLTYPE
+ #undef LoadResource
+ #undef CompareString
+ #undef GetCurrentThread
+--- dlls/wineqtdecoder/qtvdecoder.c.orig	2012-02-13 00:31:42.000000000 -0800
++++ dlls/wineqtdecoder/qtvdecoder.c	2012-02-13 00:32:30.000000000 -0800
+@@ -23,6 +23,7 @@
+ #define ULONG CoreFoundation_ULONG
+ #define HRESULT CoreFoundation_HRESULT
  
++#define BOOL __carbon_BOOL
+ #define LoadResource __carbon_LoadResource
+ #define CompareString __carbon_CompareString
+ #define GetCurrentThread __carbon_GetCurrentThread
+@@ -63,6 +64,7 @@
+ #include <QuickTime/ImageCompression.h>
+ #include <CoreVideo/CVPixelBuffer.h>
+ 
++#undef BOOL
+ #undef LoadResource
+ #undef CompareString
+ #undef GetCurrentThread
+--- dlls/dinput/joystick_osx.c.orig	2012-02-13 11:58:52.000000000 -0800
++++ dlls/dinput/joystick_osx.c	2012-02-13 11:59:09.000000000 -0800
+@@ -24,6 +24,7 @@
+ #include "wine/port.h"
+ 
+ #if defined(HAVE_IOKIT_HID_IOHIDLIB_H)
++#define BOOL __carbon_BOOL
+ #define ULONG __carbon_ULONG
+ #define E_INVALIDARG __carbon_E_INVALIDARG
+ #define E_OUTOFMEMORY __carbon_E_OUTOFMEMORY
+@@ -45,6 +46,7 @@
+ #define HRESULT __carbon_HRESULT
+ #define STDMETHODCALLTYPE __carbon_STDMETHODCALLTYPE
+ #include <IOKit/hid/IOHIDLib.h>
++#undef BOOL
+ #undef ULONG
+ #undef E_INVALIDARG
+ #undef E_OUTOFMEMORY
Index: files/sl-audio.patch
===================================================================
--- files/sl-audio.patch	(revision 90727)
+++ files/sl-audio.patch	(working copy)
@@ -1,23 +0,0 @@
---- dlls/winecoreaudio.drv/audio.c.orig	2010-07-27 14:56:49.000000000 -0500
-+++ dlls/winecoreaudio.drv/audio.c	2010-09-16 12:33:09.000000000 -0500
-@@ -56,7 +56,6 @@
- #include "wine/unicode.h"
- #include "wine/library.h"
- #include "wine/debug.h"
--#include "wine/list.h"
- 
- WINE_DEFAULT_DEBUG_CHANNEL(wave);
- 
-@@ -64,6 +63,12 @@
- 
- WINE_DECLARE_DEBUG_CHANNEL(coreaudio);
- 
-+/* This needs to be after CoreAudio/CoreAudio.h because
-+ * CoreAudio includes sys/queue.h which has namespace conflicts
-+ * with wine/list.h
-+ */
-+#include "wine/list.h"
-+
- /*
-     Due to AudioUnit headers conflict define some needed types.
- */
Index: Portfile
===================================================================
--- Portfile	(revision 90727)
+++ Portfile	(working copy)
@@ -1,3 +1,4 @@
+# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
 # $Id$
 
 PortSystem                  1.0
@@ -6,7 +7,7 @@
 
 name                        wine-crossover
 conflicts                   wine wine-devel wine-crossover-games
-version                     10.1.0
+version                     11.0.0
 license                     LGPL-2.1+
 categories                  x11
 maintainers                 jeremyhu openmaintainer
@@ -15,8 +16,9 @@
 distname                    crossover-sources-${version}
 dist_subdir                 wine
 set wine_distfile           [suffix ${distname}]
-set wine_gecko_distfile     wine_gecko-1.2.0-x86.msi
-distfiles                   ${wine_distfile} ${wine_gecko_distfile}
+set wine_gecko_version      1.4
+set wine_gecko_distfile     wine_gecko-${wine_gecko_version}-x86.msi
+distfiles                   ${wine_distfile}:winesource ${wine_gecko_distfile}:winegecko
 extract.only                ${wine_distfile}
 worksrcdir                  wine
 build.target                depend all
@@ -24,25 +26,28 @@
 
 minimum_xcodeversions       {8 2.5}
 
-description                 Wine Is Not an Emulator (1.3.9 with CodeWeavers modifications for CrossOver)
+description                 Wine Is Not an Emulator (1.4-rc5 with CodeWeavers modifications for CrossOver)
 
 long_description            Wine is an implementation of the Windows APIs on top of X11. \
                             This version contains the Codeweavers patches for CrossOver
 
-master_sites                http://media.codeweavers.com/pub/crossover/source/ \
-                            http://media.codeweavers.com/pub/crossover/source/archive/${version}/
+master_sites                http://media.codeweavers.com/pub/crossover/source/:winesource \
+                            http://media.codeweavers.com/pub/crossover/source/archive/${version}/:winesource \
+                            sourceforge:project/wine/Wine%20Gecko/${wine_gecko_version}:winegecko
 
 checksums                   ${wine_distfile} \
-                            rmd160  ff68078e199337c063f7a306d4af9cb710fee39e \
-                            sha256  b61721ffd06a649846f5afc45b5a2e0e4f533bbb19250539cdeef4035ab52067 \
+                            rmd160  38e4db61b6f3270f429a049d0d21502709265f98 \
+                            sha256  3a068f9b46feb0bbc0e87a59d294021c494da62f601375a53582f33c95129d57 \
                             ${wine_gecko_distfile} \
-                            rmd160  089447eb59eea81c7b1b3d1896a20fe68586cd96 \
-                            sha256  d6ccdb32b5867df207c7cd89513297ceb89cfa93696bece470467845c6c4d3ee
+                            rmd160  02363538a77a954f2bf1014b28ec1ed8fe2d1b6e \
+                            sha256  b30e0ac29a91a6fc40c73b5b760a56360a1d5323282545e32efaa40c75d8986d
 
 # Note: Most of the X11 libs are dlopen()'d
 depends_lib                 port:expat \
                             port:fontconfig \
                             port:freetype \
+                            port:gstreamer \
+                            port:gst-plugins-base \
                             port:jpeg \
                             port:lcms \
                             port:libiconv \
@@ -86,14 +91,15 @@
                             lib/libXrender.dylib \
                             lib/libGL.dylib
 
-depends_build               port:flex \
+depends_build               port:bison \
+                            port:flex \
                             port:pkgconfig
 
 # Extract only the wine directory. We don't need the others, and their presence
 # interferes with the wine build (which uses parts of them if present).
 extract.post_args-append    wine
 
-patchfiles                  sl-audio.patch no-quartz-wm-workaround.patch BOOL.patch
+patchfiles                  no-quartz-wm-workaround.patch BOOL.patch
 
 configure.ldflags-append    -framework CoreServices \
                             -lz