Index: Portfile
===================================================================
--- Portfile	(revision 91213)
+++ Portfile	(working copy)
@@ -6,6 +6,7 @@
 
 name                    py-novas_py
 version                 3.1
+revision                1
 categories-append       science
 platforms               darwin
 maintainers             aronnax
@@ -17,9 +18,12 @@
   and position of solar system objects.
 
 homepage                http://aa.usno.navy.mil/software/novas/novas_py/
-master_sites            ${homepage}
+master_sites            ${homepage}:py \
+                        ftp://ssd.jpl.nasa.gov/pub/eph/planets/ascii/de405/:ephemeris
 distname                NOVAS_Py-${version}
-checksums               md5     c8e57e9c33d6475a4fb170e9dec46119 \
+distfiles               ${distname}${extract.suffix}:py
+checksums               ${distname}${extract.suffix} \
+                        md5     c8e57e9c33d6475a4fb170e9dec46119 \
                         sha1    8366d2a69708d1bd1a989de48d92eb789cb9b3a2 \
                         rmd160  304837953cc1b9917585ba7dacf8c404c3c9a816
 
@@ -38,8 +42,144 @@
 
 variant DE405 description \
 {Download and prepare a JPL DE405 solar system ephemeris for use with NOVAS} {
+
+    distfiles-append    ascp1600.405:ephemeris \
+                        ascp1620.405:ephemeris \
+                        ascp1640.405:ephemeris \
+                        ascp1660.405:ephemeris \
+                        ascp1680.405:ephemeris \
+                        ascp1700.405:ephemeris \
+                        ascp1720.405:ephemeris \
+                        ascp1740.405:ephemeris \
+                        ascp1760.405:ephemeris \
+                        ascp1780.405:ephemeris \
+                        ascp1800.405:ephemeris \
+                        ascp1820.405:ephemeris \
+                        ascp1840.405:ephemeris \
+                        ascp1860.405:ephemeris \
+                        ascp1880.405:ephemeris \
+                        ascp1900.405:ephemeris \
+                        ascp1920.405:ephemeris \
+                        ascp1940.405:ephemeris \
+                        ascp1960.405:ephemeris \
+                        ascp1980.405:ephemeris \
+                        ascp2000.405:ephemeris \
+                        ascp2020.405:ephemeris \
+                        ascp2040.405:ephemeris \
+                        ascp2060.405:ephemeris \
+                        ascp2080.405:ephemeris \
+                        ascp2100.405:ephemeris \
+                        ascp2120.405:ephemeris \
+                        ascp2140.405:ephemeris \
+                        ascp2160.405:ephemeris \
+                        ascp2180.405:ephemeris \
+                        ascp2200.405:ephemeris \
+                        header.405:ephemeris
+
+    checksums-append    ascp1600.405 \
+                        rmd160  382a9db27899ace93688778fdeccdbc289b5c2a3 \
+                        sha256  4f8a05fa29e338220ff7dd734d36525aee9b66fbe9ff149a4cb31d60ce2bca90 \
+                        ascp1620.405 \
+                        rmd160  79de11121471eda2e12955c315dfc95ec849ff50 \
+                        sha256  aa78b6d9d88acbbd35f9aba9db57a154ac18ac57f834907bb74d216b00882e1b \
+                        ascp1640.405 \
+                        rmd160  6c55e500e3c98da37fb44cf64b31845999d708e0 \
+                        sha256  a1f1b310bdb732a5a612b08048801e1ff47ad4d779929c4ec52faaa795a5070f \
+                        ascp1660.405 \
+                        rmd160  e596dc7e58a4ce710312779bd9d9ddc1b77cb61d \
+                        sha256  c9add74053d2609ca77da84637a77f8357d474ad4847065bc85037e15928d419 \
+                        ascp1680.405 \
+                        rmd160  444842917234864890f5e06a0d97a207fd5e6fae \
+                        sha256  5607298bbd9896f909e407c2e4e66e3766e697e2bb29322e0e296e1bc44fa517 \
+                        ascp1700.405 \
+                        rmd160  7a1177482f330386b909cc4d9c4639953b764b2e \
+                        sha256  13d0bf4809965fc91301c11e7670899434e532962ea66b0a5c2064281cc20cbb \
+                        ascp1720.405 \
+                        rmd160  9cd1f8cfe96ceacc17e71208d843cce3a1df78c8 \
+                        sha256  62047300a9002bdc9d89dbf61a8e9e9b237c21563619a29d038938c46759b8c2 \
+                        ascp1740.405 \
+                        rmd160  1b4af8c58fcf8719651ae7b2703cc3dd54969dff \
+                        sha256  32153023fb139281e28c6be20ea69443f7035ccd7279131c192ed658b0b5f64b \
+                        ascp1760.405 \
+                        rmd160  663c77b000790909e2d3c79891d6e5b532d47e4b \
+                        sha256  e45f6f107f4943cf48e5d4969626b3d6b9098b353980259c376777dbe1f9ebfc \
+                        ascp1780.405 \
+                        rmd160  ea08e74068d5fd4feee611518ab5a08c6929d786 \
+                        sha256  533695e583949b8c19e8165d0a634571d5a5bbf1e3a8d1d0204e3fdc93c2ae0a \
+                        ascp1800.405 \
+                        rmd160  572608b84b22b97281fe0f2c4350fb5d6934949a \
+                        sha256  2d59261240d6efbf2b40e1359b15cc700ac3c6fff9e7fac58b51f4e4922f66a5 \
+                        ascp1820.405 \
+                        rmd160  a3f97b6d37cb1dda48f33b39ec65023ca14cc355 \
+                        sha256  9177d04f5435490b11491cd97d0f0a2144e65f9fff9fe72b3aec17b62157314c \
+                        ascp1840.405 \
+                        rmd160  09869321c456937357e49fd55e5aa6ec0861b2d3 \
+                        sha256  cff8fa2225b6844cc3639e46c331659912aaf40e4107b72ebf53bd874d6e4c81 \
+                        ascp1860.405 \
+                        rmd160  230177413636c7e27826db3a29ef7088a57ce4dc \
+                        sha256  81e4fc9d729d3476ef96a23de566b0ea44ff77fe5a7571d757faedae70b6d5c5 \
+                        ascp1880.405 \
+                        rmd160  c3e33f6d5040faf19cc6a19f65d87738b27431a6 \
+                        sha256  19dc41504e640a4a319c4113edfdf8b915d0255b802563769cd6ef85a7f948b1 \
+                        ascp1900.405 \
+                        rmd160  f3aea5e45aba32ecc704d02393358a9b9b4ca363 \
+                        sha256  04f7a1568e89710374be5ae4c14335de2b62aa0197c1a513562b4dac0bb5607a \
+                        ascp1920.405 \
+                        rmd160  138184aaa80cbf5a9e90d6bebbf10801d0bde940 \
+                        sha256  85b25691f32fa16a0919781594a8f12e06928357b7c4b88bbda985a537375322 \
+                        ascp1940.405 \
+                        rmd160  ab7fd094a9dbc8c448b033f3fb03d2f6eba3fc03 \
+                        sha256  08d18219c1669344e28f8f3f2682e2fb0d10dbbca3c0bb9bee4c2e2c27025a54 \
+                        ascp1960.405 \
+                        rmd160  18deca719c672993af01f152cfd96e313d21beaa \
+                        sha256  0b2ce55428dcf24adce742bb3ce97080292611df42847f4f9a9253fd0acc49fa \
+                        ascp1980.405 \
+                        rmd160  f88f9bc4d39423611a00c66486edde8a0bc2fc21 \
+                        sha256  3f5b6787b617b3339546327d38a4ad806fd40bd0b0788d10131417ec5cf05c19 \
+                        ascp2000.405 \
+                        rmd160  cc4dd6e614ae803935a9c4b6632824419fc921e1 \
+                        sha256  cf9efe6c508c02cf30aa740aa2c2d36b726aebf5db947801222e4de3c69ece2a \
+                        ascp2020.405 \
+                        rmd160  455796d41c10e3e5f30376b66424dac27032d0de \
+                        sha256  c71df85a18820129f945ae0753815d514fdf8decc7dff8375c895611e9afbbbe \
+                        ascp2040.405 \
+                        rmd160  cb51c2d0b829b8a4f3aba5c5744e413b3d74eba8 \
+                        sha256  94b33ff564f9f4c134020b857f9caae5e102fda1c3847df5b0a1329fdb198c59 \
+                        ascp2060.405 \
+                        rmd160  28780e53211566eb564a8b72288d3070ba7280a2 \
+                        sha256  19e06cd08662e2723548edb68e21ac2cf909678e8320e8d4edb8460d512dd04e \
+                        ascp2080.405 \
+                        rmd160  f413df05e4c0107a2fafc47be1d88cc816ccb1ee \
+                        sha256  ea4a6bef9cc60ed33277ea8da57957037d7073cc465a2f22d527d81e6f8fc2ce \
+                        ascp2100.405 \
+                        rmd160  9d334db2a3e8b0f821cf202440316dd04c97d3b2 \
+                        sha256  e324f3744657bd0312e12a80b82eadbd0765d706d00b6fec0a77b17f1896ecaa \
+                        ascp2120.405 \
+                        rmd160  7034278a25e55021ce9f7e1e5613c97a81b75d16 \
+                        sha256  6a67d8424f7484d732f9c2e792d80b4392a98f030937a8852ff939fa5309ba80 \
+                        ascp2140.405 \
+                        rmd160  9d2306b7c18693d78ae5407f16023e3f42e8bfd6 \
+                        sha256  9d9e6007850289d875d8ff4706877f4e567de99b1e1c3ea86ce7bf547c6e7218 \
+                        ascp2160.405 \
+                        rmd160  b346d49f0f2bb3ddc8e2326eec4ec66ff2c59558 \
+                        sha256  e03c54358f5d204dfcd8d3a188581aeaf334524eb12d63fd1c3aa7d6a3fd0cf8 \
+                        ascp2180.405 \
+                        rmd160  c9f7bed19326d3606ad211e9ff44acdbb622e6f9 \
+                        sha256  c2ee7f64464352f913140d832e62f46b49f1bb68e17c916e66366627a226d4bc \
+                        ascp2200.405 \
+                        rmd160  40ba6e5e6d6bbec5d92685b7d9f12f73baf23ba2 \
+                        sha256  17926b40bd57cc0bca76d83908183caaca6d047819f947becd20f9e56b84b6da \
+                        header.405 \
+                        rmd160  ed2b0e1bddade151bec6a1fffac16c7b8c2f92a8 \
+                        sha256  1839f173ffa0df0abd3987a6ba73c1ff8942e79eb6ec9eb7f24065816d62aa94
+
+    patchfiles-append   patch-setup.py.diff
+
+    post-extract {
+        eval copy [glob ${distpath}/*.405] ${worksrcpath}
+    }
     post-build {
-        system "cd ${worksrcpath} && ${build.cmd} build_ephemeris"
+        system -W ${worksrcpath} "${build.cmd} build_ephemeris --build-temp=."
     }
     post-destroot {
         xinstall -d ${destroot}${prefix}/share/${subport}